using System;

namespace WindowsApplication
{
	public class Dato
	{
		// Klassens felter
		private int dag;
		private int mned;
		private int r;

		// constructor
		public Dato(int dd, int mm, int aa)
		{
			dag		= dd;
			mned	= mm;
			r		= aa;
		}
		
		// Properties :
		public int Dag
		{
			get	{return dag;}
			set	{dag = value;}
		}

		public int Mned
		{
			get	{return mned;}
			set	{mned = value;}
		}
		
		public int r
		{
			get	{return r;}
			set	{r = value;}
		}
		
		// override metode
		public override string ToString()
		{
			return dag + "/" + mned + " " + r;
		}

		public string Mnedsnavn(int md) 
		{
			switch(md)
			{
				case 1: return "Januar";
				case 2: return "Februar";
				case 3: return "Marts";
				case 4: return "April";
				case 5: return "Maj";
				case 6: return "Juni";
				case 7: return "Juli";
				case 8: return "August";
				case 9: return "September";
				case 10: return "Oktober";
				case 11: return "November";
				case 12: return "December";
				default: return null;
			}// end switch
		}// end Mnedsnavn

		public void NsteDato(int d, int md, int aar) 
		{
			if (datoOK(d, md, aar))
			{
				if (d < dageIMned(md, aar)) 
					// ikke sidste dag i mned
					dag =+ 1;
				else
					// sidste dag i mned
				{
					dag = 1;
					mned =+ 1;
					if (mned > 12)
					{
						mned = 1;
						r =+ 1;
					}
				}
			}// end if datoOK
		}// end NsteDato

		public void ForrigeDato(int d, int md, int aar) 
		{
			if (datoOK(d, md, aar))
			{
				if (d > 1) 
					// ikke frste dag i mned
					dag =- 1;
				else
					// frste dag i mned
				{
					if (mned == 1)
					{
						mned = 12;
						r =- 1;
					}
					dag = dageIMned(mned, r);
								
				}
			}// end if datoOK
		}// end ForrigeDato

		public int Dagnummer()
		{
			int antdage = 0;
			for (int i = 1; i < mned ; i++)	//summer dage i
			{								//de forudgende
				antdage += dageIMned(i, r);//mneder
			}
			antdage += dag;			//lg dag i mneden til
			return antdage;
		}

		public int UgeDag()
		{
			int difdage = 4;//tir-fre fr 1/1 2000
			
			for (int i = 2000; i < r ; i++)	//summer dage i
			{									//de forudgende
				difdage += dageIr(i);			//r
			}
			difdage += Dagnummer();	//lg dag i ret til
			
			difdage %= 7; //restdivision med antal dage i ugen
			difdage += 1;
			return difdage;
		}

		public string Dagnavn()
		{
			switch(UgeDag())
			{
				case 1: return "Mandag";
				case 2: return "Tirsdag";
				case 3: return "Onsdag";
				case 4: return "Torsdag";
				case 5: return "Fredag";
				case 6: return "Lrdag";
				case 7: return "Sndag";
				default : return "Fejldag";

			}// end switch
		}

		public bool datoValider()
		{
			if (datoOK(dag, mned, r))
				return true;
			return false;
		}

		public int restdageIr()
		{
			return dageIr(r) - Dagnummer() + 1;
		}
	
		// hjlpemetoder

		private bool datoOK(int d, int md, int aar) 
		{
			if (d == 0 || d > dageIMned(md, aar))
				return false;
			else
				return true;			
		
		}// end datoOK

		private bool erSkudr(int aar) 
		{
			if (aar % 100 == 0) 
				// et helt rhundrede
			{
				if (aar % 400 == 0) // hvis deleligt med 400
					return true; // er det et skudr
				else
					return false; // ellers ikke !
			}
			else 
				// ikke et helt rhundrede
			{
				if (aar % 4 == 0) // hvis deleligt med 4
					return true; // er det et skudr
				else
					return false; // ellers ikke !
			}
		}// end erSkudr

		private int dageIMned(int md, int aar) 
		{
			switch (md)
			{
				case 1: 
				case 3:
				case 5:
				case 7:
				case 8:
				case 10:
				case 12: return 31;
				case 4:
				case 6:
				case 9:
				case 11: return 30;
				case 2: 
				{
					if (erSkudr(aar))
						return 29;
					else
						return 28;
				}
				default: return 0;

			}// end switch
		}// end dageIMned

		private int dageIr(int aar) 
		{
			int antdage = 0;
			for (int i = 1; i <= 12 ; i++)	//summer dage i
			{								//alle rets 12
				antdage += dageIMned(i, aar);	//mneder
			}
			return antdage;
			
		}// end dageIr
		
	}// end class
}
